Index: src/main/java/com/tourMate/TourMateApplication.java
===================================================================
--- src/main/java/com/tourMate/TourMateApplication.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/TourMateApplication.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -3,8 +3,17 @@
 import org.springframework.boot.SpringApplication;
 import org.springframework.boot.autoconfigure.SpringBootApplication;
+import org.springframework.context.annotation.Bean;
+import org.springframework.mail.javamail.JavaMailSender;
+import org.springframework.mail.javamail.JavaMailSenderImpl;
+import org.springframework.scheduling.annotation.EnableScheduling;
+import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
+import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.transaction.annotation.EnableTransactionManagement;
+
+import java.util.Properties;
 
 @SpringBootApplication
 @EnableTransactionManagement
+@EnableScheduling
 public class TourMateApplication {
 
@@ -13,3 +22,26 @@
 	}
 
+	@Bean
+	public PasswordEncoder passwordEncoder() {
+		return new BCryptPasswordEncoder();
+	}
+
+	@Bean
+	public JavaMailSender getJavaMailSender() {
+		JavaMailSenderImpl mailSender = new JavaMailSenderImpl();
+		mailSender.setHost("smtp.gmail.com");
+		mailSender.setPort(587);
+
+		mailSender.setUsername("trip2mk@gmail.com");
+		mailSender.setPassword("xarb ggqg mvmr zciw");
+
+		Properties props = mailSender.getJavaMailProperties();
+		props.put("mail.transport.protocol", "smtp");
+		props.put("mail.smtp.auth", "true");
+		props.put("mail.smtp.starttls.enable", "true");
+		props.put("mail.debug", "true");
+
+		return mailSender;
+	}
+
 }
Index: src/main/java/com/tourMate/config/SecurityConfig.java
===================================================================
--- src/main/java/com/tourMate/config/SecurityConfig.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/config/SecurityConfig.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,6 +1,8 @@
 package com.tourMate.config;
 
-import com.fasterxml.jackson.databind.ObjectMapper;
-import jakarta.servlet.http.HttpServletResponse;
+import com.tourMate.config.oauth2.CustomOAuth2FailureHandler;
+import com.tourMate.config.oauth2.CustomOAuth2SuccessHandler;
+import com.tourMate.config.oauth2.CustomOAuth2UserDetailService;
+import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.context.annotation.Bean;
 import org.springframework.context.annotation.Configuration;
@@ -10,6 +12,4 @@
 import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
 import org.springframework.security.config.http.SessionCreationPolicy;
-import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
-import org.springframework.security.crypto.password.PasswordEncoder;
 import org.springframework.security.web.SecurityFilterChain;
 import org.springframework.security.web.authentication.logout.HttpStatusReturningLogoutSuccessHandler;
@@ -26,4 +26,10 @@
 
     private final UserSecurity userSecurity;
+    @Autowired
+    private CustomOAuth2UserDetailService customOAuth2UserDetailService;
+    @Autowired
+    private CustomOAuth2FailureHandler oAuth2FailureHandler;
+    @Autowired
+    private CustomOAuth2SuccessHandler oAuth2SuccessHandler;
 
     public SecurityConfig(UserSecurity userSecurity) {
@@ -56,8 +62,4 @@
         return bean;
     }
-    @Bean
-    public PasswordEncoder passwordEncoder() {
-        return new BCryptPasswordEncoder();
-    }
 
     @Bean
@@ -76,25 +78,24 @@
                                         .requestMatchers(new AntPathRequestMatcher("/upload")).permitAll()
                                         .requestMatchers(new AntPathRequestMatcher("/business/approve/*")).hasAnyAuthority("SUPERADMIN")
+                                        .requestMatchers(new AntPathRequestMatcher("/users/unlock/*")).hasAnyAuthority("SUPERADMIN")
+                                        .requestMatchers(new AntPathRequestMatcher("/users/approve/*")).hasAnyAuthority("SUPERADMIN")
+                                        .requestMatchers(new AntPathRequestMatcher("/business/unapproved")).hasAnyAuthority("SUPERADMIN")
                                         .requestMatchers(new AntPathRequestMatcher("/business/add/*")).authenticated()
                                         .requestMatchers(new AntPathRequestMatcher("/*/user/{userId}")).access(userSecurity)
-                                        .anyRequest().permitAll()
-//                                        .anyRequest().authenticated()
+//                                        .anyRequest().permitAll()
+                                        .anyRequest().authenticated()
+                                        .and()
+                                        .oauth2Login()
+                                        .loginPage("/login")
+                                        .permitAll()
+                                        .userInfoEndpoint(x -> x.userService(customOAuth2UserDetailService))
+//                                        .userService(customOAuth2UserDetailService)
+                                        .successHandler(oAuth2SuccessHandler)
+                                        .failureHandler(oAuth2FailureHandler)
                                         .and()
                                         .formLogin()
-                                        .loginProcessingUrl("/api/login").usernameParameter("username").passwordParameter("password")
-                                        .successHandler((request, response, authentication) -> {
-                                            response.setStatus(HttpServletResponse.SC_OK);
-                                            response.setCharacterEncoding("UTF-8");
-                                            response.setContentType("application/json");
-                                            response.getWriter().print("{\"message\": \"Login successful\",");
-                                            response.getWriter().print("\"auth\":" + new ObjectMapper().writeValueAsString(authentication) + "}");
-                                            response.getWriter().flush();
-                                        })
-                                        .failureHandler((request, response, exception) -> {
-                                            response.setStatus(HttpServletResponse.SC_UNAUTHORIZED);
-                                            response.sendRedirect("/login");
-                                            response.getWriter().print("Neuspesna najava\n" + exception.getMessage());
-                                            response.getWriter().flush();
-                                        })
+                                        .loginPage("/login")
+                                        .successHandler(oAuth2SuccessHandler)
+                                        .permitAll()
                                         .permitAll()
                                         .and()
Index: src/main/java/com/tourMate/config/UserSecurity.java
===================================================================
--- src/main/java/com/tourMate/config/UserSecurity.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
+++ src/main/java/com/tourMate/config/UserSecurity.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -1,4 +1,6 @@
 package com.tourMate.config;
 
+import com.tourMate.config.oauth2.CustomOAuth2UserDetailService;
+import com.tourMate.config.oauth2.OAuth2UserDetailsCustom;
 import com.tourMate.entities.Hotels;
 import com.tourMate.entities.User;
@@ -25,8 +27,15 @@
     public boolean hasUserId(Authentication authentication, Long userId) {
         System.out.println(userId);
-        User user = (User) authentication.getPrincipal();
-        System.out.println(user.getUserID());
-        System.out.println(authentication.getPrincipal());
-        return userId == user.getUserID();
+        Long id;
+        if(authentication.getPrincipal() instanceof OAuth2UserDetailsCustom oAuth2UserDetailsCustom)
+        {
+            id = oAuth2UserDetailsCustom.getId();
+        }
+        else
+        {
+            User user = (User) authentication.getPrincipal();
+            id = user.getUserID();
+        }
+        return userId == id;
     }
 
Index: src/main/java/com/tourMate/config/oauth2/CustomOAuth2FailureHandler.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/CustomOAuth2FailureHandler.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/CustomOAuth2FailureHandler.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,18 @@
+package com.tourMate.config.oauth2;
+
+import jakarta.servlet.ServletException;
+import jakarta.servlet.http.HttpServletRequest;
+import jakarta.servlet.http.HttpServletResponse;
+import org.springframework.security.core.AuthenticationException;
+import org.springframework.security.web.authentication.SimpleUrlAuthenticationFailureHandler;
+import org.springframework.stereotype.Component;
+
+import java.io.IOException;
+
+@Component
+public class CustomOAuth2FailureHandler extends SimpleUrlAuthenticationFailureHandler {
+    @Override
+    public void onAuthenticationFailure(HttpServletRequest request, HttpServletResponse response, AuthenticationException exception) throws IOException, ServletException {
+        getRedirectStrategy().sendRedirect(request, response, "/login");
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/CustomOAuth2SuccessHandler.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/CustomOAuth2SuccessHandler.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/CustomOAuth2SuccessHandler.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,19 @@
+package com.tourMate.config.oauth2;
+
+import jakarta.servlet.ServletException;
+import jakarta.servlet.http.HttpServletRequest;
+import jakarta.servlet.http.HttpServletResponse;
+import org.springframework.security.core.Authentication;
+import org.springframework.security.web.authentication.SimpleUrlAuthenticationSuccessHandler;
+import org.springframework.stereotype.Component;
+
+import java.io.IOException;
+
+@Component
+public class CustomOAuth2SuccessHandler extends SimpleUrlAuthenticationSuccessHandler {
+    @Override
+    public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {
+//        OAuth2UserDetailsCustom oAuth2UserDetailsCustom = (OAuth2UserDetailsCustom) authentication.getPrincipal();
+        getRedirectStrategy().sendRedirect(request, response, "http://localhost:3000/login-callback");
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/CustomOAuth2UserDetailService.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/CustomOAuth2UserDetailService.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/CustomOAuth2UserDetailService.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,93 @@
+package com.tourMate.config.oauth2;
+
+import com.tourMate.dao.UsersDao;
+import com.tourMate.entities.Role;
+import com.tourMate.entities.User;
+import org.springframework.security.core.AuthenticationException;
+import org.springframework.security.core.authority.SimpleGrantedAuthority;
+import org.springframework.security.oauth2.client.userinfo.DefaultOAuth2UserService;
+import org.springframework.security.oauth2.client.userinfo.OAuth2UserRequest;
+import org.springframework.security.oauth2.core.OAuth2AuthenticationException;
+import org.springframework.security.oauth2.core.user.OAuth2User;
+import org.springframework.stereotype.Service;
+import org.springframework.util.ObjectUtils;
+
+import java.util.Collections;
+import java.util.Objects;
+
+@Service
+public class CustomOAuth2UserDetailService extends DefaultOAuth2UserService {
+
+    private final UsersDao usersDao;
+
+    public CustomOAuth2UserDetailService(UsersDao usersDao) {
+        this.usersDao = usersDao;
+    }
+
+    @Override
+    public OAuth2User loadUser(OAuth2UserRequest userRequest) throws OAuth2AuthenticationException {
+        OAuth2User oAuth2User = super.loadUser(userRequest);
+
+        try
+        {
+            return checkOAuth2User(userRequest, oAuth2User);
+        }
+        catch (AuthenticationException e)
+        {
+            throw e;
+        }
+        catch (Exception ex)
+        {
+            throw ex;
+            //throw new InternalAuthenticationServiceException(ex.getMessage(), ex.getCause());
+        }
+    }
+
+    private OAuth2User checkOAuth2User(OAuth2UserRequest oAuth2UserRequest, OAuth2User oAuth2User)
+    {
+        OAuth2UserDetails oAuth2UserDetails = OAuth2UserDetailsFactory
+                .createOAuth2UserDetails(oAuth2UserRequest.getClientRegistration().getRegistrationId(), oAuth2User.getAttributes());
+
+        if(ObjectUtils.isEmpty(oAuth2UserRequest))
+        {
+            throw new RuntimeException("Cannot identifty OAuth2 user!");
+        }
+
+        User user = usersDao.findByUsernameAndProvider(
+                oAuth2UserDetails.getEmail(),
+                oAuth2UserRequest.getClientRegistration().getRegistrationId());
+        User userDetails = null;
+        if(user != null)
+        {
+            userDetails = user;
+            userDetails = updateOAuth2UserDetail(userDetails, oAuth2UserDetails);
+        }
+        else
+        {
+            userDetails = registerOAuth2UserDetail(oAuth2UserRequest, oAuth2UserDetails);
+        }
+        return new OAuth2UserDetailsCustom(
+                userDetails.getUserID(),
+                userDetails.getUsername(),
+                userDetails.getPassword(),
+                Collections.singletonList(new SimpleGrantedAuthority(userDetails.getRole().getRoleName()))
+        );
+    }
+
+    public User registerOAuth2UserDetail(OAuth2UserRequest oAuth2UserRequest, OAuth2UserDetails oAuth2UserDetails)
+    {
+        Role r = usersDao.findById(1L);
+        User user = new User();
+        user.setName(Objects.requireNonNullElse(oAuth2UserDetails.getName(), ""));
+        user.setEmail(oAuth2UserDetails.getEmail());
+        user.setProvider(oAuth2UserRequest.getClientRegistration().getRegistrationId());
+        user.setRole(r);
+        return usersDao.updateUser(user);
+    }
+
+    public User updateOAuth2UserDetail(User user, OAuth2UserDetails oAuth2UserDetails)
+    {
+        user.setEmail(oAuth2UserDetails.getEmail());
+        return usersDao.mergeUser(user);
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2FacebookUser.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2FacebookUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2FacebookUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,19 @@
+package com.tourMate.config.oauth2;
+
+import java.util.Map;
+
+public class OAuth2FacebookUser extends OAuth2UserDetails{
+    public OAuth2FacebookUser(Map<String, Object> attributes) {
+        super(attributes);
+    }
+
+    @Override
+    public String getName() {
+        return (String) attributes.get("name");
+    }
+
+    @Override
+    public String getEmail() {
+        return (String) attributes.get("email");
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2GitHubUser.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2GitHubUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2GitHubUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,19 @@
+package com.tourMate.config.oauth2;
+
+import java.util.Map;
+
+public class OAuth2GitHubUser extends OAuth2UserDetails{
+    public OAuth2GitHubUser(Map<String, Object> attributes) {
+        super(attributes);
+    }
+
+    @Override
+    public String getName() {
+        return (String) attributes.get("name");
+    }
+
+    @Override
+    public String getEmail() {
+        return (String) attributes.get("login");
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2GoogleUser.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2GoogleUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2GoogleUser.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,19 @@
+package com.tourMate.config.oauth2;
+
+import java.util.Map;
+
+public class OAuth2GoogleUser extends OAuth2UserDetails{
+    public OAuth2GoogleUser(Map<String, Object> attributes) {
+        super(attributes);
+    }
+
+    @Override
+    public String getName() {
+        return (String) attributes.get("name");
+    }
+
+    @Override
+    public String getEmail() {
+        return (String) attributes.get("email");
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2UserDetails.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2UserDetails.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2UserDetails.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,14 @@
+package com.tourMate.config.oauth2;
+
+import java.util.Map;
+
+public abstract class OAuth2UserDetails {
+    protected Map<String, Object> attributes;
+
+    public OAuth2UserDetails(Map<String, Object> attributes) {
+        this.attributes = attributes;
+    }
+
+    public abstract String getName();
+    public abstract String getEmail();
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsCustom.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsCustom.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsCustom.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,83 @@
+package com.tourMate.config.oauth2;
+
+import jakarta.persistence.Column;
+import org.springframework.security.core.GrantedAuthority;
+import org.springframework.security.core.userdetails.UserDetails;
+import org.springframework.security.oauth2.core.user.OAuth2User;
+
+import java.util.Collection;
+import java.util.List;
+import java.util.Map;
+
+public class OAuth2UserDetailsCustom implements OAuth2User, UserDetails {
+
+    Long id;
+    String username;
+    String password;
+    List<GrantedAuthority> authorities;
+    Map<String, Object> attributes;
+    Boolean locked = true;
+    Boolean enabled = true;
+    Boolean expired = false;
+
+
+    public OAuth2UserDetailsCustom(Long id, String username, String password, List<GrantedAuthority> authorities) {
+        this.id = id;
+        this.username = username;
+        this.password = password;
+        this.authorities = authorities;
+    }
+
+    @Override
+    public String getPassword() {
+        return password;
+    }
+
+    @Override
+    public String getUsername() {
+        return username;
+    }
+
+    @Override
+    public boolean isAccountNonExpired() {
+        return expired;
+    }
+
+    @Override
+    public boolean isAccountNonLocked() {
+        return locked;
+    }
+
+    @Override
+    public boolean isCredentialsNonExpired() {
+        return true;
+    }
+
+    @Override
+    public boolean isEnabled() {
+        return enabled;
+    }
+
+    @Override
+    public Map<String, Object> getAttributes() {
+        return attributes;
+    }
+
+    @Override
+    public Collection<? extends GrantedAuthority> getAuthorities() {
+        return authorities;
+    }
+
+    @Override
+    public String getName() {
+        return String.valueOf(id);
+    }
+
+    public Long getId() {
+        return id;
+    }
+
+    public void setId(Long id) {
+        this.id = id;
+    }
+}
Index: src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsFactory.java
===================================================================
--- src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsFactory.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
+++ src/main/java/com/tourMate/config/oauth2/OAuth2UserDetailsFactory.java	(revision 0f5aa2759dde06c45eeb640feeb15cb583c6af32)
@@ -0,0 +1,27 @@
+package com.tourMate.config.oauth2;
+
+import com.tourMate.entities.Providers;
+
+import java.util.Map;
+
+public class OAuth2UserDetailsFactory {
+    public static OAuth2UserDetails createOAuth2UserDetails (String registrationId, Map<String, Object> attributes)
+    {
+        if(registrationId.equals(Providers.google.name()))
+        {
+            return new OAuth2GoogleUser(attributes);
+        }
+        else if(registrationId.equals(Providers.facebook.name()))
+        {
+            return new OAuth2FacebookUser(attributes);
+        }
+        else if(registrationId.equals(Providers.github.name()))
+        {
+            return new OAuth2GitHubUser(attributes);
+        }
+        else
+        {
+            throw  new RuntimeException("Login with this provider is not supported!");
+        }
+    }
+}
